required: 
  #- schema #To be enabled at a later date. Must be part of the public release
  - status
  - query
  - scheduling

tide.template.force-required:
  - schema

if:
  allOf:
    - properties:
        scheduling:
          properties:
            nrt: 
              enum: [true]
    - properties:
        scheduling:
          required: [nrt]
then: 
  allOf:
    - not: {required: [trigger]}
    - not: {required: [threshold]}


properties:

  schema:
    title: Schema identifier and version
    type: string
    description: Identifier of the schema at its current version 
    const: sentinel::2.0
    tide.template.force-required: True

  status: 
    title: Status of the use-case
    type: string
    description: Define the status according to use case development life cycle process
    tide.vocab: true
    example: STAGING
    default: DEVELOPMENT

  contributors:
    title: Development Contributors
    type: array
    description: Individuals who supported creating, enriching or tuning the detection. 
    items:
      type: string
      format: email

  trigger: 
    title: Trigger Operator
    type: string
    description: |
      The operation against the threshold that triggers alert rule.
      
      ⚠️ If you create a NRT rule, this value must be removed or commented out (NRT rules trigger an alert on the first match)
    default: GreaterThan
    icon: 🔫
    enum:
      - Equal
      - GreaterThan
      - LessThan
      - NotEqual

  threshold: 
    title: Event threshold
    type: integer
    description: | 
      If amount of events is higher than threshold (during the timeframe) the alert is triggered. 

      ⚠️ If you create a NRT rule, this value must be removed or commented out (NRT rules trigger an alert on the first match)
    example: 10
    default: 0
    tide.mdr.parameter: triggerThreshold

  scheduling:
    title: Throttling parameters
    type: object
    description: Configuration for throttling incoming alerts 
    tide.template.force-required:
      - frequency
      - lookback
    if: 
      properties:
        nrt: 
          enum: [false]
    then: 
      allOf:
        - required: [frequency]
        - required: [lookback]
    else:
      allOf:
        - not: {required: [frequency]}
        - not: {required: [lookback]}

    properties:
      nrt:
        title: Near Real Time Rule
        type: boolean
        default: false
        description: |
          NRT rules are hard-coded to run once every minute and capture events
          ingested in the preceding minute, so as to be able to supply you with
          information as up-to-the-minute as possible.

          ⚠️ You can not turn a ScheduledAlert into a NRT Rule or vice versa. Once
          the MDR is deployed under this UUID, if it must be transformed into
          a different type, a new UUID must be attributed and the previous rule
          manually removed from Sentinel.

      frequency: 
        title: Recurring Search Interval
        type: string
        description: Time intervals at which the scheduled search should be ran at, from 5m to up to 14days. Format is X d|h|m. If you create a NRT rule, this value must be removed or commented out.
        markdownDescription: |
          Time intervals at which the scheduled search should be ran at

          💡 _You can use `d`, `h` or `m` to represent `days`, `hours` and `minutes` respectively_
      
          Note that Sentinel supports frequency intervals **from 5 minutes up to 14 days** only, translating to the
          maximum values for lookback configuration : `14d`, `337h` or `20160m`

          ⚠️ If you create a NRT rule, this value must be removed or commented out (NRT rules work on the smallest possible timeframe)
        example: 5m
        pattern: "^((([1-9]|1[0-4])d)|(([1-9]|[1-9][0-9]|[1-2][0-9][0-9]|3[0-2][0-9]|33[0-7])h)|(([5-9]|[1-9][0-9]{1,3}|1[0-9]{0,4}|200[0-9][0-9]|201[0-5][0-9]|20160)m))$"
        tide.mdr.parameter: queryFrequency
      
      lookback: 
        title: Lookback Configuration
        type: string
        description: Duration of logs to search in, up to 14 days. Format is X d|h|m. If you create a NRT rule, this value must be removed or commented out.
        markdownDescription: |
          Duration of logs to search in. 
          
          💡 _You can use `d`, `h` or `m` to represent `days`, `hours` and `minutes` respectively_
      
          Note that Sentinel supports lookback periods **up to 14 days** only, translating to the
          maximum values for lookback configuration : `14d`, `337h` or `20160m`
          
          ⚠️ If you create a NRT rule, this value must be removed or commented out (NRT rules work on the smallest possible timeframe)

        example: 5m
        pattern: "^((([0-9]|1[0-4])d)|(([1-9]|[1-9][0-9]|[1-2][0-9][0-9]|3[0-2][0-9]|33[0-7])h)|(([1-9]|[1-9][0-9]{1,3}|1[0-9]{0,4}|200[0-9][0-9]|201[0-5][0-9]|20160)m))$"
        tide.mdr.parameter: queryPeriod

  alert:
    title: Alert Configuration
    icon: 🚨
    description: >-
      Alert Details allow analytic rules to have dynamic values for the Displayed
      name, Description, Tactics and Severity properties of the alert. By using
      dynamic alert details, the same rule can generate different incidents, for
      example with different severity. Also, the information displayed to the
      analyst can include variable information such as relevant entity names to 
      help the analyst understand the incident faster.
    type: object
    anyOf:
      - required:
          - title
      - required:
          - description
    properties:

      create_incident:
        title: Create Incident
        type: boolean
        default: true 
        description: Create incidents from alerts triggered by this analytics rule
        tide.mdr.parameter: incidentConfiguration.createIncident

      suppression:
        title: Alert Suppression
        type:
          - string
          - boolean
        description: The duration to wait since last time this alert rule been triggered. Set to "false" to disable all suppression.
        pattern: "^(((1d)|(([1-9]|1[0-9]|2[0-4])h)|(([5-9]|[1-9][0-9]{1,2}|1[0-3][0-9][0-9]|14[0-3][0-9]|1440)m)))|false$"
        tide.mdr.parameter: suppressionDuration

      title:
        title: Alert Display Name Format
        type: string
        description: Free text with field names embedded using the format {{columnName}}. Up to 256 chars and 3 placeholders.
        example: rule {{columnName1}} display name
        tide.mdr.parameter: alertDetailsOverride.alertDisplayNameFormat

      description: 
        title: Alert Description Format
        type: string
        tide.template.multiline : True
        description: Free text with field names embedded using the format {{columnName}}. Up to 5000 chars and 3 placeholders
        example: rule {{columnName1}} display name
        tide.mdr.parameter: alertDetailsOverride.alertDescriptionFormat
      

      custom_details:
        title: Custom Details
        icon: 💬
        type: array
        description: Surface particular event parameters and their values in alerts that comprise those events, by adding key-value pairs below.
        tide.mdr.parameter: customDetails
        items:
          type: object
          required:
            - key
            - column
          properties:
            key:
              type: string
              icon: 🗝️
              description: Enter a name of your choosing that will appear as the field name in alerts.
              pattern: ^[^\s]*$
            column:
              icon: 💽
              description: Choose the column which value should be added as a custom detail. Must exist in the result of the query.
              type: string
      
      dynamic_properties:
        title: Alert Dynamic Properties
        icon: 💽
        type: array
        description: Override alert default properties, select an alert property from the Alert property drop-down list.
        tide.mdr.parameter: alertDetailsOverride.alertDynamicProperties
        items:
          type: object
          required: 
            - property
            - column
          properties:
            property:
              icon: 🗝️
              type: string
              description: The V3 Alert Property
              tide.mdr.parameter: alertProperty
              enum:
                - AlertLink
                - ConfidenceLevel
                - ConfidenceScore
                - ExtendedLinks
                - ProductComponentName
                - ProductName
                - ProviderName
                - RemediationSteps
                - Severity
                - Tactics
                - Techniques
            column:
              icon: 💽
              description: Choose the column which value should override the alert property. Must exist in the result of the query.
              type: string
              tide.mdr.parameter: value

  grouping:
    title: Grouping Setup
    type: object
    icon: 💠
    properties: 
      event:
        title: Event Grouping Details
        icon: 📣
        tide.mdr.parameter: eventGroupingSettings.aggregationKind
        description: Configure how rule query results are grouped into alerts.
        type: string
        default: SingleAlert
        anyOf:
          - const: AlertPerResult
            description: Trigger an alert for each event
          - const: SingleAlert
            description: Group all events into a single alert
      
      alert:
        title: Alert Grouping Details
        icon: 🚨
        type: object
        description: Set how the alerts that are triggered by this analytics rule, are grouped into incidents. Grouping alerts into incidents provides the context you need to respond and reduces the noise from single alerts.
        markdownDescription: |
          Set how the alerts that are triggered by this analytics rule, are grouped into incidents.
          Grouping alerts into incidents provides the context you need to respond and reduces the noise from single alerts.
        
          > 📌 Up to 150 alerts can be grouped into a single incident. If more than 150 alerts are generated, a new incident
          will be created with the same incident details as the original, and the excess alerts will be grouped into the
          new incident.
        required:
          - enabled
        
        allOf:
          - if:
              properties:
                enabled: 
                  const: true
            then:
              required:
                - grouping_lookback
                - matching

          - if:
              properties:
                matching:
                  const: Selected
            then:
              anyOf:
                - required:
                    - group_by_entities
                - required:
                    - group_by_alert_details
                - required:
                    - group_by_custom_details
        
        properties:
          
          enabled:
            title: Enable Alert Grouping
            icon: 🎚️
            type: boolean
            tide.mdr.parameter: incidentConfiguration.groupingConfiguration.enabled # Complex nesting example

          reopen_closed_incidents:
            title: Re-Open Closed Incidents
            type: boolean
            icon: ⛩️
            tide.mdr.parameter: incidentConfiguration.groupingConfiguration.reopenClosedIncident
            description: Re-open closed matching incidents

          grouping_lookback:
            title: Timeframe to Group Alerts
            icon: ⏳
            type: string #Need to regex validate and be converted to ISO 8601 in code like lookback and frequecy. Would be a chore for devs to do.
            description: Limit the group to alerts created within the selected time frame.
            tide.mdr.parameter: incidentConfiguration.groupingConfiguration.lookbackDuration
          
          matching: # Limiting matching methods for now
            title: Matching Method
            icon: ❤️‍🔥
            type: string
            default: AllEntities
            description: Group alerts triggered by this analytics rule into a single incident using defined methods.
            tide.mdr.parameter: incidentConfiguration.groupingConfiguration.matchingMethod
            anyOf:
              - const: AllEntities
                description: Grouping alerts into a single incident if all the entities match (recommended)
              - const: AnyAlert
                description: Grouping all alerts triggered by this rule into a single incident
              - const: Selected
                description: | 
                  Grouping alerts into a single incident if the selected entities, custom details and alert details match.
                  ⚠️ When using this option, ensure that the values you enter were already configured in the MDR.

          group_by_entities:
            title: Entity Alert Grouping
            icon: 🧊
            type: array
            tide.mdr.parameter: incidentConfiguration.groupingConfiguration.groupByEntities
            description: A list of entity types to group by (when matchingMethod is Selected). Only entities defined in the current alert rule may be used.
            tide.template.hide: true
            items:
              uniqueItems: true
              enum:
                - Account
                - AzureResource
                - CloudApplication
                - DNS
                - File
                - FileHas
                - Host
                - IP
                - MailCluster
                - MailMessage
                - Mailbox
                - Malware
                - Process
                - RegistryKey
                - RegistryValue
                - SecurityGroup
                - SubmissionMail
                - URL
          
          group_by_alert_details:
            title: Alert Details Alert Grouping
            description: A list of alert details to group by (when matchingMethod is Selected)
            tide.mdr.parameter: incidentConfiguration.groupingConfiguration.groupByAlertDetails
            type: array
            icon: 💬
            tide.template.hide: true
            items:
              uniqueItems: true
              enum:
                - DisplayName
                - Severity
          
          group_by_custom_details:
            title: Custom Details Alert Grouping
            description: A list of custom details keys to group by (when matchingMethod is Selected). Only keys defined in the current alert rule may be used.
            tide.mdr.parameter: incidentConfiguration.groupingConfiguration.groupByCustomDetails
            type: array
            icon: 💬
            tide.template.hide: true
            items:
              type: string

          
          
  entities:
    title: Entity Mappings
    description: Entity mapping is an integral part of the configuration of scheduled query analytics rules. It enriches the rules' output (alerts and incidents) with essential information that serves as the building blocks of any investigative processes and remedial actions that follow.
    icon: 🧊
    tide.mdr.parameter: entityMappings
    tide.mdr.parameter_nest: True # Will reproduce nested data structure before being added to the API request body (normally, flattening process would destroy this structure). 
    tide.template.spacer: true # Forces the template synthesis to add a space
    maxItems: 5
    type: array
    items:
      type: object
      required:
        - entity
        - mappings

      oneOf:
        - properties:
            entity:
              {type: string, enum: [Account]}
            mappings:
              type: array
              maxItems: 3
              contains: # This implements the required identifier concept
                type: object
                properties:
                  identifier:
                    enum: [Sid, Name, AadUserId, PUID, ObjectGuid]
              items:
                type: object
                properties:
                  identifier:
                    anyOf:
                      - const: Name
                        description: The name of the account. This field should hold only the name without any domain added to it.
                        markdownDescription: |
                          The name of the account. This field should hold only the name without any domain added to it.

                          Required: **Yes**
                      - const: NTDomain
                        description: 'The NETBIOS domain name as it appears in the alert format – domain\username. Examples: Finance, NT AUTHORITY'
                        markdownDescription: |
                          The NETBIOS domain name as it appears in the alert format – domain\username. Examples: Finance, NT AUTHORITY

                          Required: **No**
                      - const: DnsDomain
                        description: 'The fully qualified domain DNS name. Examples: finance.contoso.com'
                        markdownDescription: |
                          The fully qualified domain DNS name. Examples: finance.contoso.com

                          Required: **No**
                      - const: UPNSuffix
                        description: 'The user principal name suffix for the account. In some cases this is also the domain name. Examples: contoso.com'
                        markdownDescription: |
                          The user principal name suffix for the account. In some cases this is also the domain name. Examples: contoso.com

                          Required: **No**
                      - const: Sid
                        description: The account security identifier, such as S-1-5-18.
                        markdownDescription: |
                          The account security identifier, such as S-1-5-18.

                          Required: **Yes**
                      - const: AadTenantId
                        description: The Azure AD tenant ID, if known.
                        markdownDescription: |
                          The Azure AD tenant ID, if known.

                          Required: **No**
                      - const: AadUserId
                        description: The Azure AD account object ID, if known.
                        markdownDescription: |
                          The Azure AD account object ID, if known.

                          Required: **Yes**
                      - const: PUID
                        description: The Azure AD Passport User ID, if known.
                        markdownDescription: |
                          The Azure AD Passport User ID, if known.

                          Required: **Yes**
                      - const: IsDomainJoined
                        description: Determines whether this is a domain account.
                        markdownDescription: |
                          Determines whether this is a domain account.

                          Required: **No**
                      - const: DisplayName
                        description: The display name of the account.
                        markdownDescription: |
                          The display name of the account.

                          Required: **No**
                      - const: ObjectGuid
                        description: The objectGUID attribute is a single-value attribute that is the unique identifier for the object, assigned by Active Directory.
                        markdownDescription: |
                          The objectGUID attribute is a single-value attribute that is the unique identifier for the object, assigned by Active Directory.

                          Required: **Yes**


        - properties:
            entity:
              {type: string, enum: [Host]}
            mappings:
              type: array
              maxItems: 3
              contains:
                type: object
                properties:
                  identifier:
                    enum: [HostName, NetBiosName, AzureID, OMSAgentID]
              items:
                type: object
                properties:
                  identifier:
                    anyOf:
                      - const: DnsDomain
                        description: The DNS domain that this host belongs to. Should contain the complete DNS suffix for the domain, if known.
                        markdownDescription: |
                          The DNS domain that this host belongs to. Should contain the complete DNS suffix for the domain, if known.

                          Required: **No**
                      - const: NTDomain
                        description: The NT domain that this host belongs to.
                        markdownDescription: |
                          The NT domain that this host belongs to.

                          Required: **No**
                      - const: HostName
                        description: The hostname without the domain suffix.
                        markdownDescription: |
                          The hostname without the domain suffix.

                          Required: **Yes**
                      - const: NetBiosName
                        description: The host name (pre-Windows 2000).
                        markdownDescription: |
                          The host name (pre-Windows 2000).

                          Required: **Yes**
                      - const: AzureID
                        description: The Azure resource ID of the VM, if known.
                        markdownDescription: |
                          The Azure resource ID of the VM, if known.

                          Required: **Yes**
                      - const: OMSAgentID
                        description: The OMS agent ID, if the host has OMS agent installed.
                        markdownDescription: |
                          The OMS agent ID, if the host has OMS agent installed.

                          Required: **Yes**
                      - const: OSFamily
                        description: 'One of the following values: Linux, Windows, Android, IOS'
                        markdownDescription: |
                          One of the following values:
                          - Linux
                          - Windows
                          - Android
                          - IOS

                          Required: **No**
                      - const: OSVersion
                        description: A free-text representation of the operating system.
                        markdownDescription: |
                          A free-text representation of the operating system.
                          
                          _This field is meant to hold specific versions the are more fine-grained
                          than OSFamily, or future values not supported by OSFamily enumeration._

                          Required: **No**
                      - const: IsDomainJoined
                        description: Determines whether this host belongs to a domain.
                        markdownDescription: |
                          Determines whether this host belongs to a domain.

                          Required: **No**

        - properties:
            entity:
              {type: string, enum: [IP]}
            mappings:
              type: array
              maxItems: 2
              contains:
                type: object
                properties:
                  identifier:
                    enum: [Address]
              items:
                type: object
                properties:
                  identifier:
                    anyOf:
                      - const: Address
                        description: The IP address as string, e.g. 127.0.0.1 (either in IPv4 or IPv6).
                        markdownDescription: |
                          The IP address as string, e.g. 127.0.0.1 (either in IPv4 or IPv6).

                          Required: **Yes**
                      - const: AddressScope
                        description: 'CURRENTLY UNDOCUMENTED BY MICROSOFT, BUT ACCESSIBLE ON GUI'
                        markdownDescription: |
                          ⚠️ CURRENTLY UNDOCUMENTED BY MICROSOFT, BUT ACCESSIBLE ON GUI

                          Required: **No**

        - properties:
            entity:
              {type: string, enum: [Malware]}
            mappings:
              type: array
              maxItems: 2
              contains:
                type: object
                properties:
                  identifier:
                    enum: [Name]
              items:
                type: object
                properties:
                  identifier:
                    anyOf:
                      - const: Name
                        description: The malware name by the vendor, such as Win32/Toga!rfn.
                        markdownDescription: |
                          The malware name by the vendor, such as `Win32/Toga!rfn`.
                          
                          Required: **Yes**
                      - const: Category
                        description: The malware category by the vendor, e.g. Trojan.
                        markdownDescription: |
                          The malware category by the vendor, e.g. Trojan.

                          Required: **No**

        - properties:
            entity:
              {type: string, enum: [File]}
            mappings:
              type: array
              maxItems: 2
              contains:
                type: object
                properties:
                  identifier:
                    enum: [Name]
              items:
                type: object
                properties:
                  identifier:
                    anyOf:
                      - const: Name
                        description: The file name without the path (some alerts might not include path).
                        markdownDescription: | 
                          The file name without the path (some alerts might not include path).

                          Required: **Yes**
                      - const: Directory
                        description: The full path to the file.
                        markdownDescription: |
                          The full path to the file.

                          Required: **No**

        - properties:
            entity:
              {type: string, enum: [Process]}
            mappings:
              type: array
              maxItems: 3
              contains:
                type: object
                properties:
                  identifier:
                    enum: [CommandLine, ProcessId]
              items:
                type: object
                properties:
                  identifier:
                    anyOf:
                      - const: ProcessId
                        description: The process ID.
                        markdownDescription: |
                          The process ID.

                          Required: **Yes**
                      - const: CommandLine
                        description: The command line used to create the process.
                        markdownDescription: |
                          The command line used to create the process.

                          Required: **Yes**
                      - const: ElevationToken
                        description: The elevation token associated with the process.
                        markdownDescription: |
                          The elevation token associated with the process.
                          
                          Possible values:
                          
                          - TokenElevationTypeDefault                   
                          - TokenElevationTypeFull
                          - TokenElevationTypeLimited

                          Required: **No**
                      - const: CreationTimeUtc
                        description: The time when the process started to run.
                        markdownDescription: |
                          The time when the process started to run.

                          Required: **No**


        - properties:
            entity:
              {type: string, enum: [CloudApplication]}
            mappings:
              type: array
              maxItems: 3
              contains:
                type: object
                properties:
                  identifier:
                    enum: [AppId, Name]
              items:
                type: object
                properties:
                  identifier:
                    anyOf:
                      - const: AppId
                        description: The technical identifier of the application. This should be one of the values defined in the list of cloud application identifiers. The value for AppId field is optional.
                        markdownDescription: |
                          The technical identifier of the application. This should be one of the values defined in the list of
                          [cloud application identifiers](https://learn.microsoft.com/en-us/azure/sentinel/entities-reference#cloud-application-identifiers).
                          The value for AppId field is optional.
                          
                          Required: **Yes**
                      - const: Name
                        description: The name of the related cloud application. The value of application name is optional.
                        markdownDescription: |
                          The name of the related cloud application. The value of application name is optional.
                          
                          Required: **Yes**
                      - const: InstanceName
                        description: The user-defined instance name of the cloud application. It is often used to distinguish between several applications of the same type that a customer has.
                        markdownDescription: |
                          The user-defined instance name of the cloud application. It is often used to distinguish between several
                          applications of the same type that a customer has.

                          Required: **No**

        - properties:
            entity:
              {type: string, enum: [DNS]}
            mappings:
              type: array
              maxItems: 3
              contains:
                type: object
                properties:
                  identifier:
                    enum: [DomainName]
              items:
                type: object
                properties:
                  identifier:
                    anyOf:
                      - const: DomainName
                        description: The name of the DNS record associated with the alert.
                        markdownDescription: |
                          The name of the DNS record associated with the alert.

                          Required: **Yes**

        - properties:
            entity:
              {type: string, enum: [AzureResource]}
            mappings:
              type: array
              maxItems: 3
              contains:
                type: object
                properties:
                  identifier:
                    enum: [ResourceId]
              items:
                type: object
                properties:
                  identifier:
                    anyOf:
                      - const: ResourceId
                        description: The Azure resource ID of the resource.
                        markdownDescription: |
                          The Azure resource ID of the resource.

                          Required: **Yes**

        - properties:
            entity:
              {type: string, enum: [FileHash]}
            mappings:
              type: array
              maxItems: 2
              contains:
                type: object
                properties:
                  identifier:
                    enum: [Value]
              items:
                type: object
                properties:
                  identifier:
                    anyOf:
                      - const: Algorithm
                        description: The hash algorithm type
                        markdownDescription: |
                          The hash algorithm type. Possible values:
                          - Unknown
                          - MD5
                          - SHA1
                          - SHA256
                          - SHA256AC

                          Required: **No**
                      - const: Value
                        description: The hash value.
                        markdownDescription: |
                          The hash value.
                          
                          Required: **Yes**

        - properties:
            entity:
              {type: string, enum: [RegistryKey]}
            mappings:
              type: array
              maxItems: 2
              contains:
                type: object
                properties:
                  identifier:
                    enum: [Hive, Key]
              items:
                type: object
                properties:
                  identifier:
                    anyOf:
                      - const: Hive
                        description: | 
                          'One of the following values: HKEY_LOCAL_MACHINE, HKEY_CLASSES_ROOT,
                          HKEY_CURRENT_CONFIG, HKEY_USERS, HKEY_CURRENT_USER_LOCAL_SETTINGS,
                          HKEY_PERFORMANCE_DATA, HKEY_PERFORMANCE_NLSTEXT, HKEY_PERFORMANCE_TEXT,
                          HKEY_A, HKEY_CURRENT_USER'
                        markdownDescription: |
                          One of the following values:
                          - HKEY_LOCAL_MACHINE
                          - HKEY_CLASSES_ROOT
                          - HKEY_CURRENT_CONFIG
                          - HKEY_USERS
                          - HKEY_CURRENT_USER_LOCAL_SETTINGS
                          - HKEY_PERFORMANCE_DATA
                          - HKEY_PERFORMANCE_NLSTEXT
                          - HKEY_PERFORMANCE_TEXT
                          - HKEY_A
                          - HKEY_CURRENT_USER

                          Required: **Yes**
                      - const: Key
                        description: The registry key path.
                        markdownDescription: |
                          The registry key path.

                          Required: **Yes**

        - properties:
            entity:
              {type: string, enum: [RegistryValue]}
            mappings:
              type: array
              maxItems: 3
              contains:
                type: object
                properties:
                  identifier:
                    enum: [Name]
              items:
                type: object
                properties:
                  identifier:
                    anyOf:
                      - const: Name 
                        description: The registry value name.
                        markdownDescription: |
                          The registry value name.

                          Required: **Yes**
                      - const: Value
                        description: String-formatted representation of the value data.
                        markdownDescription: |
                          String-formatted representation of the value data.

                          Required: **No**
                      - const: ValueType
                        description: 'One of the following values: String, Binary, DWord, Qword, MultiString, ExpandString, None, Unknown'
                        markdownDescription: |
                          One of the following values:
                          - String
                          - Binary
                          - DWord
                          - Qword
                          - MultiString
                          - ExpandString
                          - None
                          - Unknown

                          _Values should conform to Microsoft.Win32.RegistryValueKind enumeration._

                          Required: **No**

        - properties:
            entity:
              {type: string, enum: [SecurityGroup]}
            mappings:
              type: array
              maxItems: 3
              contains:
                type: object
                properties:
                  identifier:
                    enum: [DistinguishedName, SID, ObjectGuid]
              items:
                type: object
                properties:
                  identifier:
                    anyOf:
                      - const: DistinguishedName
                        description: The group distinguished name.
                        markdownDescription: |
                          The group distinguished name.

                          Required: **Yes**
                      - const: SID
                        description: The SID attribute is a single-value attribute that specifies the security identifier (SID) of the group.
                        markdownDescription: |
                          The SID attribute is a single-value attribute that specifies the security identifier (SID) of the group.

                          Required: **Yes**
                      - const: ObjectGuid
                        description: The objectGUID attribute is a single-value attribute that is the unique identifier for the object, assigned by Active Directory.
                        markdownDescription: |
                          The objectGUID attribute is a single-value attribute that is the unique identifier for the object, assigned by Active Directory.

                          Required: **Yes**

        - properties:
            entity:
              {type: string, enum: [URL]}
            mappings:
              type: array
              maxItems: 1
              contains:
                type: object
                properties:
                  identifier:
                    enum: [Url]
              items:
                type: object
                properties:
                  identifier:
                    anyOf:
                      - const: Url
                        description: A full URL the entity points to.
                        markdownDescription: |
                          A full URL the entity points to.
                          
                          Required: **Yes**

        - properties:
            entity:
              {type: string, enum: [IoTDevice]}
            mappings:
              type: array
              maxItems: 3
              contains:
                type: object
                properties:
                  identifier:
                    enum: [DeviceId]
              items:
                type: object
                properties:
                  identifier:
                    anyOf:
                      - const: DeviceId
                        description: The ID of the device in the context of the IoT Hub.
                        markdownDescription: |
                          The ID of the device in the context of the IoT Hub.

                          Required: **Yes**
                      - const: DeviceName
                        description: The friendly name of the device.
                        markdownDescription: |
                          The friendly name of the device.

                          Required: **No**
                      - const: IoTSecurityAgentId
                        description: The ID of the Defender for IoT agent running on the device.
                        markdownDescription: |
                          The ID of the _Defender for IoT_ agent running on the device.

                          Required: **No**
                      - const: DeviceType
                        description: The type of the device ('temperature sensor', 'freezer', 'wind turbine' etc.).
                        markdownDescription: |
                          The type of the device ('temperature sensor', 'freezer', 'wind turbine' etc.).

                          Required: **No**
                      - const: Source
                        description: The source (Microsoft/Vendor) of the device entity.
                        markdownDescription: |
                          The source (Microsoft/Vendor) of the device entity.

                          Required: **No**
                      - const: Manufacturer
                        description: The manufacturer of the device.
                        markdownDescription: |
                          The manufacturer of the device.

                          Required: **No**
                      - const: Model
                        description: The model of the device.
                        markdownDescription: |
                          The model of the device.

                          Required: **No**
                      - const: OperatingSystem
                        description: The operating system the device is running.
                        markdownDescription: |
                          The operating system the device is running.

                          Required: **No**
                      - const: MacAddress
                        description: The MAC address of the device.
                        markdownDescription: |
                          The MAC address of the device.

                          Required: **No**
                      - const: Protocols
                        description: A list of protocols that the device supports.
                        markdownDescription: |
                          A list of protocols that the device supports.
                          
                          Required: **No**
                      - const: SerialNumber
                        description: The MAC address of the device.
                        markdownDescription: |
                          The MAC address of the device.

                          Required: **No**

        - properties:
            entity:
              {type: string, enum: [Mailbox]}
            mappings:
              type: array
              maxItems: 3
              contains:
                type: object
                properties:
                  identifier:
                    enum: [MailboxPrimaryAddress]
              items:
                type: object
                properties:
                  identifier:
                    anyOf:
                      - const: MailboxPrimaryAddress
                        description: The mailbox's primary address.
                        markdownDescription: |
                          The mailbox's primary address.

                          Required: **Yes**
                      - const: DisplayName
                        description: The mailbox's display name.
                        markdownDescription: |
                          Required: **No**
                      - const: Upn
                        description: The mailbox's UPN.
                        markdownDescription: |
                          The mailbox's UPN.

                          Required: **No**
                      - const: RiskLevel
                        description: 'The risk level of this mailbox. Possible values: None, Low, Medium, High'
                        markdownDescription: |
                          The risk level of this mailbox. Possible values:
                          - None
                          - Low
                          - Medium
                          - High

                          Required: **No**
                      - const: ExternalDirectoryObjectId
                        description: The AzureAD identifier of mailbox. Similar to AadUserId in the Account entity, but this property is specific to mailbox object on the Office side.
                        markdownDescription: |
                          The AzureAD identifier of mailbox. Similar to AadUserId in the Account entity, but this property is specific to mailbox object on the Office side.

                          Required: **No**

        - properties:
            entity:
              {type: string, enum: [MailCluster]}
            mappings:
              type: array
              maxItems: 3
              contains:
                type: object
                properties:
                  identifier:
                    enum: [Query, Source]
              items:
                type: object
                properties:
                  identifier:
                    anyOf:
                      - const: NetworkMessageIds
                        description: The mail message IDs that are part of the mail cluster.
                        markdownDescription: |
                          The mail message IDs that are part of the mail cluster.

                          Required: **No**
                      - const: CountByDeliveryStatus
                        description: The mail message IDs that are part of the mail cluster.
                        markdownDescription: |
                          The mail message IDs that are part of the mail cluster.

                          Required: **No**
                      - const: CountByThreatType
                        description: Count of mail messages by ThreatType string representation.
                        markdownDescription: |
                          Count of mail messages by ThreatType string representation.

                          Required: **No**
                      - const: CountByProtectionStatus
                        description: Count of mail messages by Threat Protection status.
                        markdownDescription: |
                          Count of mail messages by Threat Protection status.

                          Required: **No**
                      - const: Threats
                        description: The threats of mail messages that are part of the mail cluster.
                        markdownDescription: |
                          The threats of mail messages that are part of the mail cluster.

                          Required: **No**
                      - const: Query
                        description: The query that was used to identify the messages of the mail cluster.
                        markdownDescription: |
                          The query that was used to identify the messages of the mail cluster.

                          Required: **Yes**
                      - const: QueryTime
                        description: The query time.
                        markdownDescription: |
                          The query time.

                          Required: **No**
                      - const: MailCount
                        description: The number of mail messages that are part of the mail cluster.
                        markdownDescription: |
                          The number of mail messages that are part of the mail cluster.

                          Required: **No**
                      - const: IsVolumeAnomaly
                        description: Determines whether this is a volume anomaly mail cluster.
                        markdownDescription: |
                          Determines whether this is a volume anomaly mail cluster.

                          Required: **No**
                      - const: Source
                        description: The source of the mail cluster (default is 'O365 ATP').
                        markdownDescription: |
                          The source of the mail cluster (default is 'O365 ATP').

                          Required: **Yes**
                      - const: ClusterSourceIdentifier
                        description: The network message ID of the mail that is the source of this mail cluster.
                        markdownDescription: |
                          The network message ID of the mail that is the source of this mail cluster.

                          Required: **No**
                      - const: ClusterSourceType
                        description: The source type of the mail cluster. This maps to the MailClusterSourceType setting from Microsoft Defender for Office 365.
                        markdownDescription: |
                          The source type of the mail cluster. This maps to the MailClusterSourceType setting from Microsoft Defender for Office 365.

                          > 👉 _Microsoft Defender for Office 365 was formerly known as Office 365 Advanced Threat Protection (O365 ATP)._

                          Required: **No**
                      - const: ClusterQueryStartTime
                        description: Cluster start time - used as start time for cluster counts query. Usually dates to the End time minus DaysToLookBack setting from Microsoft Defender for Office 365.
                        markdownDescription: |
                          Cluster start time - used as start time for cluster counts query. Usually dates to the End time minus DaysToLookBack setting from Microsoft Defender for Office 365.

                          > 👉 _Microsoft Defender for Office 365 was formerly known as Office 365 Advanced Threat Protection (O365 ATP)._

                          Required: **No**
                      - const: ClusterQueryEndTime
                        description: Cluster end time - used as end time for cluster counts query. Usually the mail data's received time.
                        markdownDescription: |
                          Cluster end time - used as end time for cluster counts query. Usually the mail data's received time.

                          Required: **No**
                      - const: ClusterGroup
                        description: Corresponds to the Kusto query key used on Microsoft Defender for Office 365.
                        markdownDescription: |
                          Corresponds to the Kusto query key used on Microsoft Defender for Office 365.

                          > 👉 _Microsoft Defender for Office 365 was formerly known as Office 365 Advanced Threat Protection (O365 ATP)._

                          Required: **No**

        - properties:
            entity:
              {type: string, enum: [MailMessage]}
            mappings:
              type: array
              maxItems: 3
              contains:
                type: object
                properties:
                  identifier:
                    enum: [NetworkMessageId, Recipient]
              items:
                type: object
                properties:
                  identifier:
                    anyOf:
                      - const: Recipient
                        description: The recipient of this mail message. In the case of multiple recipients, the mail message is copied, and each copy has one recipient.
                        markdownDescription: |
                          The recipient of this mail message. In the case of multiple recipients, the mail message is copied, and each copy has one recipient.

                          Required: **Yes**
                      - const: Urls
                        description: The URLs contained in this mail message.
                        markdownDescription: |
                          The URLs contained in this mail message.

                          Required: **No**
                      - const: Threats
                        description: The threats contained in this mail message.
                        markdownDescription: |
                          The threats contained in this mail message.

                          Required: **No**
                      - const: Sender
                        description: The sender's email address.
                        markdownDescription: |
                          The sender's email address.

                          Required: **No**
                      - const: P1Sender
                        description: Email ID of (delegated) user who sent this mail "on-behalf of P2 (primary) user". If email not sent by delegate, this value is equal to P2Sender.
                        markdownDescription: |
                          Email ID of (delegated) user who sent this mail "on-behalf of P2 (primary) user".
                          If email not sent by delegate, this value is equal to P2Sender.

                          Required: **No**
                      - const: P1SenderDisplayName
                        description: Display name of the (delegated) user who sent this mail "on behalf of P2 (primary) user". Represented in email header by "OnbehalfofSenderDisplayName" property.
                        markdownDescription: |
                          Display name of the (delegated) user who sent this mail "on behalf of P2 (primary) user".
                          Represented in email header by "OnbehalfofSenderDisplayName" property.

                          Required: **No**
                      - const: P1SenderDomain
                        description: Email domain of the (delegated) user who sent this mail "on behalf of P2 (primary) user". If email not sent by delegate, this value is equal to P2SenderDomain.
                        markdownDescription: |
                          Email domain of the (delegated) user who sent this mail "on behalf of P2 (primary) user".
                          If email not sent by delegate, this value is equal to P2SenderDomain.

                          Required: **No**
                      - const: P2Sender
                        description: Email of the (primary) user on behalf of whom this email was sent.
                        markdownDescription: |
                          Email of the (primary) user on behalf of whom this email was sent.

                          Required: **No**
                      - const: P2SenderDisplayName
                        description: Display name of the (primary) user on behalf of whom this email was sent. If email not sent by delegate, this represents the display name of the sender.
                        markdownDescription: |
                          Display name of the (primary) user on behalf of whom this email was sent.
                          If email not sent by delegate, this represents the display name of the sender.

                          Required: **No**
                      - const: P2SenderDomain
                        description: Email domain of the (primary) user on behalf of whom this email was sent. If email not sent by delegate, this represents the domain of the sender.
                        markdownDescription: |
                          Email domain of the (primary) user on behalf of whom this email was sent.
                          If email not sent by delegate, this represents the domain of the sender.

                          Required: **No**
                      - const: SenderIP
                        description: The sender's IP address.
                        markdownDescription: |
                          The sender's IP address.

                          Required: **No**
                      - const: ReceivedDate
                        description: The received date of this message.
                        markdownDescription: |
                          The received date of this message.

                          Required: **No**
                      - const: NetworkMessageId
                        description: The internet message ID of this mail message.
                        markdownDescription: |
                          The internet message ID of this mail message.

                          Required: **Yes**
                      - const: InternetMessageId
                        description: The internet message ID of this mail message.
                        markdownDescription: |
                          The internet message ID of this mail message.

                          Required: **No**
                      - const: Subject
                        description: The subject of this mail message.
                        markdownDescription: |
                          The subject of this mail message.

                          Required: **No**
                      - const: BodyFingerprintBin1
                        description: Used by Microsoft Defender for Office 365 to find matching or similar mail messages.
                        markdownDescription: |
                          Used by Microsoft Defender for Office 365 to find matching or similar mail messages.

                          Required: **No**
                      - const: BodyFingerprintBin2
                        description: Used by Microsoft Defender for Office 365 to find matching or similar mail messages.
                        markdownDescription: |
                          Used by Microsoft Defender for Office 365 to find matching or similar mail messages.

                          Required: **No**
                      - const: BodyFingerprintBin3
                        description: Used by Microsoft Defender for Office 365 to find matching or similar mail messages.
                        markdownDescription: |
                          Used by Microsoft Defender for Office 365 to find matching or similar mail messages.

                          Required: **No**
                      - const: BodyFingerprintBin4
                        description: Used by Microsoft Defender for Office 365 to find matching or similar mail messages.
                        markdownDescription: |
                          Used by Microsoft Defender for Office 365 to find matching or similar mail messages.

                          Required: **No**
                      - const: BodyFingerprintBin5
                        description: The directionality of this mail message.
                        markdownDescription: |
                          The directionality of this mail message. Possible values:
                          - Unknown
                          - Inbound
                          - Outbound
                          - Intraorg (internal)

                          Required: **No**
                      - const: AntispamDirection
                        description: The directionality of this mail message. 
                        markdownDescription: |
                          The directionality of this mail message. Possible values:
                          - Unknown
                          - Inbound
                          - Outbound
                          - Intraorg (internal)

                          Required: **No**
                      - const: DeliveryAction
                        description: The delivery action of this mail message.
                        markdownDescription: |
                          The delivery action of this mail message. Possible values:
                          - Unknown
                          - DeliveredAsSpam
                          - Delivered
                          - Blocked
                          - Replaced

                          Required: **No**
                      - const: DeliveryLocation
                        description: The delivery location of this mail message. 
                        markdownDescription: |
                          The delivery location of this mail message. Possible values:
                          - Unknown
                          - Inbox
                          - JunkFolder
                          - DeletedFolder
                          - Quarantine
                          - External
                          - Failed
                          - Dropped
                          - Forwarded

                          Required: **No**
                      - const: Language
                        description: The language in which the contents of the mail are written.
                        markdownDescription: |
                          The language in which the contents of the mail are written.

                          Required: **No**
                      - const: ThreatDetectionMethods
                        description: The list of Threat Detection Methods applied on this mail.
                        markdownDescription: |
                          The list of Threat Detection Methods applied on this mail.

                          Required: **No**
        
        
        - properties:
            entity:
              {type: string, enum: [SentinelEntities]}
            mappings:
              type: array
              maxItems: 1
              contains:
                type: object
                properties:
                  identifier:
                    enum: [Entities]
              items:
                type: object
                properties:
                  identifier:
                    anyOf:
                      - const: Entities
                        description: A list of the entities identified in the alert.
                        markdownDescription: |
                          A list of the entities identified in the alert.
                          This list is the entities column from the SecurityAlert schema ([see documentation](https://learn.microsoft.com/en-us/azure/sentinel/security-alert-schema)).

                          Required: **Yes**
        
        
        - properties:
            entity:
              {type: string, enum: [SubmissionMail]}
            mappings:
              type: array
              maxItems: 3
              contains:
                type: object
                properties:
                  identifier:
                    enum: [SubmissionId, NetworkMessageId, Recipient, Submitter]
              items:
                type: object
                properties:
                  identifier:
                    anyOf:
                      - const: SubmissionId
                        description: The Submission ID.
                        markdownDescription: |
                          The Submission ID.

                          Required: **Yes**
                      - const: SubmissionDate
                        description: Reported Date time for this submission.
                        markdownDescription: |
                          Reported Date time for this submission.

                          Required: **No**
                      - const: Submitter
                        description: The submitter email address.
                        markdownDescription: |
                          The submitter email address.

                          Required: **Yes**
                      - const: NetworkMessageId
                        description: The network message ID of email to which submission belongs.
                        markdownDescription: |
                          The network message ID of email to which submission belongs.

                          Required: **Yes**
                      - const: Timestamp
                        description: The Time stamp when the message is received (Mail).
                        markdownDescription: |
                          The Time stamp when the message is received (Mail).

                          Required: **No**
                      - const: Recipient
                        description: The recipient of the mail.
                        markdownDescription: |
                          The recipient of the mail.

                          Required: **Yes**
                      - const: Sender
                        description: The sender of the mail.
                        markdownDescription: |
                          The sender of the mail.

                          Required: **No**
                      - const: SenderIp
                        description: The sender's IP.
                        markdownDescription: |
                          The sender's IP.

                          Required: **No**
                      - const: Subject
                        description: The subject of submission mail.
                        markdownDescription: |
                          The subject of submission mail.

                          Required: **No**
                      - const: ReportType
                        description: The submission type for the given instance. This maps to Junk, Phish, Malware or NotJunk.
                        markdownDescription: |
                          The submission type for the given instance. This maps to Junk, Phish, Malware or NotJunk.

                          Required: **No**

      properties:
          entity:
            title: Sentinel Entity
            icon: 🧊
            description: Entity Type for which attributes available as identifier are mapped to.
            tide.mdr.parameter: entityType
            markdownDescription: |
              Each mapped entity can identify **_up to ten entities._**

              - If an alert contains more than ten items that correspond to a single entity
              mapping, only the first ten will be recognized as entities and be able to be analyzed as such.
              - This limitation applies to actual mappings, not to entity types. So if you have three
              different mapped entities for IP addresses (say, source, destination, and gateway), each of
              those mappings can accommodate ten entities.
            type: string
            anyOf:
              - const: Account
                description: User account entity type
                markdownDescription: |
                  ### 👤 Account

                  _User account entity type_

                  Required identifiers : _Sid, Name, AadUserId, PUID, ObjectGuid_

                  **Strong identifiers of an account entity:**

                  - Name + UPNSuffix
                  - AadUserId
                  - Sid + Host (required for SIDs of builtin accounts)
                  - Sid (except for SIDs of builtin accounts)
                  - Name + NTDomain (unless NTDomain is a builtin domain, for example "Workgroup")
                  - Name + Host (if NTDomain is a builtin domain, for example "Workgroup")
                  - Name + DnsDomain
                  - PUID
                  - ObjectGuid
                  
                  **Weak identifiers of an account entity:**

                  - Name
              - const: AzureResource
                description: Azure resource entity type
                markdownDescription: |
                  ### 💎 Azure Resource

                  _Azure resource entity type_

                  Required identifiers : _ResourceId_

                  **Strong identifiers of an Azure resource entity:**

                  - ResourceId
              - const: CloudApplication
                description: Cloud app entity type
                markdownDescription: |
                  ### ⛅ Cloud Application
                  
                  _Cloud app entity type_

                  Required identifiers : _AppId, Name_

                  **Strong identifiers of a cloud application entity:**

                  - AppId (without InstanceName)
                  - Name (without InstanceName)
                  - AppId + InstanceName
                  - Name + InstanceName
              - const: DNS
                description: DNS entity type
                markdownDescription: |
                  ### 🌐 Domain Name

                  _DNS entity type_

                  Required identifiers : _DomainName_

                  **Strong identifiers of a DNS entity:**
                  
                  - DomainName + DnsServerIp + HostIpAddress
                  
                  **Weak identifiers of a DNS entity:**
                  
                  - DomainName + HostIpAddress
              - const: File
                description: System file entity type
                markdownDescription: |
                  ### 📄 File Entity

                  _System file entity type_

                  Required identifiers : _Name_

                  **Strong identifiers of a file entity:**

                  - Name + Directory
                  - Name + FileHash
                  - Name + Directory + FileHash
              - const: FileHash
                description: File-hash entity type
                markdownDescription: |
                  ### 🧩 File Hash

                  _File-hash entity type_

                  Required identifiers : _Algorithm + Value_

                  **Strong identifiers of a file hash entity:**

                  - Algorithm + Value
              - const: Host
                description: Host entity type
                markdownDescription: |
                  ### 🖥️ Host

                  _Host entity type_

                  Required identifiers : _HostName, NetBiosName, AzureID, OMSAgentID_

                  **Strong identifiers of a host entity:**

                  - HostName + NTDomain
                  - HostName + DnsDomain
                  - NetBiosName + NTDomain
                  - NetBiosName + DnsDomain
                  - AzureID
                  - OMSAgentID
                  - IoTDevice (not supported for entity mapping)

                  **Weak identifiers of a host entity:**

                  - HostName
                  - NetBiosName
              - const: IoTDevice
                description: IoT device entity type
                markdownDescription: |
                  ### 🖲️ IoT device

                  _IoT device entity type_

                  Required identifiers : _DeviceId_

                  **Strong identifiers of an IoT device entity:**

                  - IoTHub + DeviceId

                  **Weak identifiers of a IoT device entity:** 

                  - DeviceId (without IoTHub)
              - const: IP
                description: IP address entity type
                markdownDescription: |
                  ### 🌐 IP Address

                  _IP address entity type_

                  Required identifiers : _Address_

                  **Strong identifiers of an IP entity:**

                  - Address
              - const: MailCluster
                description: Mail cluster entity type
                markdownDescription: |
                  ### 📩 Mail Cluster

                  _Mail cluster entity type_

                  Required identifiers : _Query, Source_

                  **Strong identifiers of a mail cluster entity:**

                  - Query + Source
                
              - const: MailMessage
                description: Mail message address entity type
                markdownDescription: |
                  ### 📧 Mail Message

                  _Mail message entity type_

                  Required identifiers : _NetworkMessageId, Recipient_

                  **Strong identifiers of a mail message entity:**

                  - NetworkMessageId + Recipient
              - const: Mailbox
                description: Mailbox entity type
                markdownDescription: |
                  ### 📬 Mailbox

                  _Mailbox entity type_

                  Required identifiers : _MailboxPrimaryAddress_

                  **Strong identifiers of a mailbox entity:**

                  - MailboxPrimaryAddress
              - const: Malware
                description: Malware entity type
                markdownDescription: |
                  ### ☣️ Malware

                  _Malware entity type_

                  Required identifiers : _Name_

                  **Strong identifiers of a malware entity:**

                  - Name + Category
              - const: Process
                description: Process entity type
                markdownDescription: |
                  ### ⚙️ Process

                  _Process entity type_

                  Required identifiers : _CommandLine, ProcessId_

                  **Strong identifiers of a process entity:**

                  - Host + ProcessId + CreationTimeUtc
                  - Host + ParentProcessId + CreationTimeUtc + CommandLine
                  - Host + ProcessId + CreationTimeUtc + ImageFile
                  - Host + ProcessId + CreationTimeUtc + ImageFile.FileHash

                  **Weak identifiers of a process entity:**

                  - ProcessId + CreationTimeUtc + CommandLine (and no Host)
                  - ProcessId + CreationTimeUtc + ImageFile (and no Host)
              - const: RegistryKey 
                description: Registry key entity type
                markdownDescription: |
                  ### 🗄️ Registry Key

                  _Registry key entity type_

                  Required identifiers : _Hive, Key_

                  **Strong identifiers of a registry key entity:**

                  - Hive + Key
              - const: RegistryValue
                description:  Registry value entity type
                markdownDescription: |
                  ### 🗃️ Registry Value

                  _Registry value entity type_

                  Required identifiers : _Name_

                  **Strong identifiers of a registry value entity:**

                  - Key + Name

                  **Weak identifiers of a registry value entity:**

                  - Name (without Key)
              - const: SecurityGroup
                description: Security group entity type
                markdownDescription: |
                  ### 🔐 Security Group

                  _Security group entity type_

                  Required identifiers : _DistinguishedName, SID, ObjectGuid_

                  **Strong identifiers of a security group entity:**

                  - DistinguishedName
                  - SID
                  - ObjectGuid
              - const: SubmissionMail
                description:  Sumission mail entity type
                markdownDescription: |
                  ### 📨 Submission Mail

                  _Submission mail entity type_

                  Required identifiers : _SubmissionId, NetworkMessageId, Recipient, Submitter_

                  **Strong identifiers of a submission mail entity:**

                  - SubmissionId
                  - Submitter
                  - NetworkMessageId
                  - Recipient
              - const: URL
                description: URL entity type
                markdownDescription: |
                  ### 🔗 URL

                  _URL entity type_

                  Required identifiers : _Url_

                  **Strong identifiers of a URL entity:**

                  - Url (when an absolute URL)

                  **Weak identifiers of a URL entity:** 

                  - Url (when a relative URL)
              - const: SentinelEntities
                description: Sentinel Entities entity type
                markdownDescription: |
                  ### 🧊 Sentinel Entities

                  _Sentinel Entities entity type_

                  Maps against a list of the entities. This list can include a combination of entities of different types.

                  > ⚠️ This entity type is not well known or documented, and should be considered experimental. Make
                  sure to test in the GUI to confirm the correct behaviour before using this feature.

                  Required identifiers : _Entities_


          mappings:
            title: Entity Mappings
            type: array
            icon: 🗺️
            description: Identifier and Column combination for the chosen entity type
            tide.mdr.parameter : fieldMappings
            items:
              type: object
              required:
                - identifier
                - column


              properties:
                
                identifier:
                  title: Entity Identifier
                  icon: 📍
                  description: Identifier used to provide identification for the chosen entity.
                  markdownDescription: |
                    Each one of the identifiers in the **required identifiers** column is minimally necessary to identify its entity.
                    However, a required identifier might not, by itself, be sufficient to provide _unique_ identification.
                    The more identifiers used, the greater the likelihood of unique identification. You can use up to
                    three identifiers for a single entity mapping.
                    
                    For best results - for guaranteed unique identification - you should use identifiers from the **strongest
                    identifiers** column whenever possible. The use of multiple strong identifiers enables correlation
                    between strong identifiers from varying data sources and schemas. This in turn allows Microsoft
                    Sentinel to provide more comprehensive insights for a given entity.
                  type: string
                  tide.mdr.parameter: identifier
                
                column:
                  title: Data Table Column
                  icon: 🪘
                  type: string
                  description: The column name to be mapped to the identifier. Note that it must be a valid column name available in the query result from the KQL chosen.
                  tide.mdr.parameter: columnName


  query: 
    title: Sentinel KQL Detection Rule
    type: string
    tide.template.multiline : True
    tide.template.spacer: true # Forces the template synthesis to add a space
    description: Scheduled query in KQL language
    example: 'SignInLogs | evaluate bag_unpack(LocationDetails)'